/*  RAGE2X for GP2X

    Copyright (C) 2006  JyCet

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

void write_cfg()
{
	//prepare rage2x_cms.save
	rage2x_cmd.save = 
		(rage2x_cmd.etat[15]<<15) | (rage2x_cmd.etat[14]<<14) | (rage2x_cmd.etat[13]<<13) | (rage2x_cmd.etat[12]<<12) |
		(rage2x_cmd.etat[11]<<11) | (rage2x_cmd.etat[10]<<10) | (rage2x_cmd.etat[9]<<9) | (rage2x_cmd.etat[8]<<8) |
		(rage2x_cmd.etat[7]<<7) | (rage2x_cmd.etat[6]<<6) | (rage2x_cmd.etat[5]<<5) | (rage2x_cmd.etat[4]<<4) |
		(rage2x_cmd.etat[3]<<3) | (rage2x_cmd.etat[2]<<2) | (rage2x_cmd.etat[1]<<1) | (rage2x_cmd.etat[0]) ;
	//prepare chemin prog sortie
	//quit.temp = (char*) calloc( strlen(quit.path) + strlen(quit.prg) + 1, sizeof(char));
	//strcpy ( quit.temp , quit.path );
	//strcat ( quit.temp , quit.prg );
	
	fp = fopen("rage2x.cfg", "w");
	fputs("# GNGEO LAUNCH OPTIONS\n",fp);
	fputs("\n",fp);
	fputs("# roms path\n",fp);
	fputs("# romspath1 is the first scanned folder\n",fp);
	sprintf((char*)g_string, "romspath1 %s\n",options.path[0]);
	fputs(g_string,fp);
	sprintf((char*)g_string, "romspath2 %s\n",options.path[1]);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# show framerate\n",fp);
	fputs("# 1 enable\n",fp);
	fputs("# 0 disable (default)\n",fp);
	sprintf((char*)g_string, "showfps %d\n",options.fps);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# sound\n",fp);
	fputs("# 0 disable (very fast emulation)\n",fp);
	fputs("# 1 enable (slow down)\n",fp);
	sprintf((char*)g_string, "sound %d\n",options.sound);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# sample rate\n",fp);
	fputs("# 0 for 11025Hz (faster than 22050Hz)\n",fp);	// modifi pour la 0.9beta
	fputs("# 1 for 22050Hz (default)\n",fp);			// modifi pour la 0.9beta
	fputs("# 2 for 44100Hz (new)\n",fp);			// ajout pour la 0.9beta
	sprintf((char*)g_string, "samplerate %d\n",options.rate);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# set the cpu clock for gngeo2x\n",fp);
#ifdef WIZ
	fputs("# from 100MHz to 910MHz\n",fp);			// modifi pour la 0.9beta
#else
	fputs("# from 100MHz to 310MHz\n",fp);			// modifi pour la 0.9beta
#endif
	sprintf((char*)g_string, "cpuclock %d\n",options.cpu);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# set the 68000 clock for gngeo2x\n",fp);
	fputs("# from -50\% to +50\%\n",fp);
	sprintf((char*)g_string, "cpu68k %d\n",options.cpu68k);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# set the Z80 clock for gngeo2x\n",fp);
	fputs("# from -50\% to +50\%\n",fp);
	sprintf((char*)g_string, "cpuz80 %d\n",options.cpuz80);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# automatic reload of RAGE2X\n",fp);
	fputs("# 0 disable (default)\n",fp);
	fputs("# 1 enable\n",fp);
	sprintf((char*)g_string, "autoreloadgui %d\n",options.reload);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# raster effect for side kick game\n",fp);
	fputs("# 0 disable (default)\n",fp);
	fputs("# 1 enable (slow down emulation)\n",fp);
	sprintf((char*)g_string, "raster %d\n",options.raster);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# screen resolution\n",fp);
	fputs("# 0 304x224\n",fp);
	fputs("# 1 320x224 (default)\n",fp);
	sprintf((char*)g_string, "screen %d\n",options.largeur);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# system choice\n",fp);
	fputs("# 0 console\n",fp);
	fputs("# 1 arcade\n",fp);
	fputs("# 2 unibios\n",fp);
	sprintf((char*)g_string, "system %d\n",options.system);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# country (not used with unibios)\n",fp);
	fputs("# 0 japan\n",fp);
	fputs("# 1 usa\n",fp);
	fputs("# 2 europe\n",fp);
	sprintf((char*)g_string, "country %d\n",options.pays);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# enable Craigix's ram tweak\n",fp);
	sprintf((char*)g_string, "tweak %d\n",options.tweak);
	fputs(g_string,fp);
	fputs("# enable vertical synchronization\n",fp);
	sprintf((char*)g_string, "vsync %d\n",options.vsync);
	fputs(g_string,fp);
#ifdef WIZ
	fputs("# enable GP2X Wiz double buffering\n",fp);
	sprintf((char*)g_string, "doublebuf %d\n",options.doublebuf);
	fputs(g_string,fp);
	fputs("# enable GP2X Wiz tearing fix\n",fp);
	sprintf((char*)g_string, "tearingfix %d\n",options.tearingfix);
	fputs(g_string,fp);
#else
	fputs("# enable GNGEO2X TV-Out\n",fp);
	sprintf((char*)g_string, "tvout %d\n",options.tvout);
	fputs(g_string,fp);
	fputs("# change TV-Out X axis offset\n",fp);
	sprintf((char*)g_string, "tvoffset_x %d\n",options.tvoffset_x);
	fputs(g_string,fp);
	fputs("# change TV-Out Y axis offset\n",fp);
	sprintf((char*)g_string, "tvoffset_y %d\n",options.tvoffset_y);
	fputs(g_string,fp);
#endif
	fputs("# enable dump sprite\n",fp);
	sprintf((char*)g_string, "dumpsprite %d\n",options.dumpsprite);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("\n",fp);
	fputs("# RAGE2X GUI OPTIONS\n",fp);
	fputs("\n",fp);
	fputs("# set GUI speed\n",fp);
	fputs("# from 0 to 2 (0 is the faster)\n",fp);
	sprintf((char*)g_string, "guispeed %d\n",options.guispeed);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# frontend language\n",fp);
	fputs("# 0 english (default)\n",fp);
	sprintf((char*)g_string, "guilangue %d\n",options.langue);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# listing view\n",fp);
	fputs("# 0 all (default)\n",fp);
	fputs("# 1 available\n",fp);
	fputs("# 2 missing\n",fp);
	sprintf((char*)g_string, "guilisting %d\n",options.listing);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# Invert run choice\n",fp);
	fputs("# 0 without *cf in first (default)\n",fp);
	fputs("# 1 with *.cf in first\n",fp);
	sprintf((char*)g_string, "invertrun %d\n",options.inv_run);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# RAGE2X clock setting\n",fp);
	fputs("# from 66MHz to 133MHz (100MHz default)\n",fp);
	sprintf((char*)g_string, "rage2xclock %d\n",options.rage2xclock);
	fputs(g_string,fp);
	fputs("# background scrolling\n",fp);
	sprintf((char*)g_string, "rage2xscrollbg %d\n",options.scrollbg);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# external options states save\n",fp);
	sprintf((char*)g_string, "rage2x_cmd %d\n",rage2x_cmd.save);
	fputs(g_string,fp);
	fputs("\n",fp);
	fputs("# program run at exit\n",fp);
	sprintf((char*)g_string, "exit_program %s\n", quit.temp );
	fputs(g_string,fp);
	fputs("\n",fp);
	fclose(fp);
	
	sync();
	
	reset_frame_skip();
}

void write_cf(unsigned char numero)
{
	sprintf((char*)g_string, "conf/%s.cf",data.zip[list[numero][options.listing]]);
	fp = fopen(g_string, "w");
	fputs("# Config file generate by RAGE2X\n",fp);
	sprintf((char*)g_string, "# %s\n",data.name[list[numero][options.listing]]);
	fputs(g_string,fp);
	fputs("\n",fp);

	sprintf((char*)g_string, "cpu_speed %d\n",options.cpu);
	fputs(g_string,fp);
	sprintf((char*)g_string, "68kclock %d\n",options.cpu68k);
	fputs(g_string,fp);
	sprintf((char*)g_string, "z80clock %d\n",options.cpuz80);
	fputs(g_string,fp);
	if (options.sound) fputs("sound true\n",fp);
	else fputs("sound false\n",fp);
		
	if (options.rate==0) fputs("samplerate 11025\n",fp);			// modifi pour la 0.9beta
	else if (options.rate==1) fputs("samplerate 22050\n",fp);		// modifi pour la 0.9beta
	else fputs("samplerate 44100\n",fp);					// ajout pour la 0.9beta
		
	if (options.fps) fputs("showfps true\n",fp);
	else fputs("showfps false\n",fp);
	if (options.raster) fputs("raster true\n",fp);
	else fputs("raster false\n",fp);
	if (options.system==0) fputs("system console\n",fp);
	else if (options.system==1) fputs("system arcade\n",fp);
	else  fputs("system unibios\n",fp);
	if (options.pays==0) fputs("country japan\n",fp);
	else if (options.pays==1) fputs("country usa\n",fp);
	else fputs("country europe\n",fp);
	if (options.largeur) fputs("screen320 true\n",fp);
	else fputs("screen320 false\n",fp);
	fclose(fp);
	
	sync();
	
	reset_frame_skip();
}
